#ifndef __CAPTURE_HEADER_INCLUDED__
#define __CAPTURE_HEADER_INCLUDED__

#include <signal.h> /* For sig_atomic_t */

#define CAP_STATE_NULL		0 /* Not started */
#define CAP_STATE_ENDED		0 /* Finished */
#define CAP_STATE_INIT		1 /* Initialised */
#define CAP_STATE_CAPTURE	2 /* mid-capture */
#define CAP_STATE_STOP		3 /* Stopping */
#define CAP_STATE_INT		4 /* Interrupted */

#define __have_cap_s
struct cap_s {
	struct capdev		*capdev;
	sig_atomic_t		state;
	char			*args;
	void			*priv;
};

#ifndef __PLUGIN__
void capture_init(void);
void capture_add(char *, char *);
void capture_go(void);
void capture_stop(void);
void capture_interrupt(void);
#endif

#endif /* __CAPTURE_HEADER_INCLUDED__ */
